package perpetualbox;

public class Entity {

	private Pos pos;
	private World world = null;
	private int terrainData;
	private Pos gravityOffset = new Pos(0, 1);
	
	public Entity(Pos inputPos, int inputTerrainData) {
		pos = inputPos;
		terrainData = inputTerrainData;
	}
	
	public World getWorld() {
		return world;
	}
	
	public void setWorld(World inputWorld) {
		if (world != null) {
			world.removeTerrainBlock(pos);
		}
		world = inputWorld;
		world.addTerrainBlock(pos, terrainData);
	}
	
	public Pos getPos() {
		return pos;
	}
	
	public void stepOverObstacle(Pos pos, Pos offset) {
		
	}
	
	public void setPos(Pos inputPos) {
		world.addBoxUpdatesAbovePos(pos);
		world.removeTerrainBlock(pos);
		pos.set(inputPos);
		world.addTerrainBlock(pos, terrainData);
	}
	
	public void move(Pos offset) {
		Pos tempPos = pos.copy();
		if (offset.getX() > 0) {
			tempPos.setX(tempPos.getX() + 2);
			if (world.getTerrainData(tempPos, false) != 0) {
				stepOverObstacle(tempPos, offset);
				return;
			}
			tempPos.setY(tempPos.getY() + 1);
			if (world.getTerrainData(tempPos, false) != 0) {
				stepOverObstacle(tempPos, offset);
				return;
			}
		}
		if (offset.getX() < 0) {
			tempPos.setX(tempPos.getX() - 1);
			if (world.getTerrainData(tempPos, false) != 0) {
				stepOverObstacle(tempPos, offset);
				return;
			}
			tempPos.setY(tempPos.getY() + 1);
			if (world.getTerrainData(tempPos, false) != 0) {
				stepOverObstacle(tempPos, offset);
				return;
			}
		}
		if (offset.getY() > 0) {
			tempPos.setY(tempPos.getY() + 2);
			if (world.getTerrainData(tempPos, false) != 0) {
				return;
			}
			tempPos.setX(tempPos.getX() + 1);
			if (world.getTerrainData(tempPos, false) != 0) {
				return;
			}
		}
		if (offset.getY() < 0) {
			tempPos.setY(tempPos.getY() - 1);
			if (world.getTerrainData(tempPos, false) != 0) {
				return;
			}
			tempPos.setX(tempPos.getX() + 1);
			if (world.getTerrainData(tempPos, false) != 0) {
				return;
			}
		}
		tempPos.set(pos);
		tempPos.add(offset);
		setPos(tempPos);
	}
	
	public void tick() {
		move(gravityOffset);
	}
	
}
